/**
   * @license
   * author: Richard Shephard
   * stencil-tailwind-plugin.js v1.2.1
   * Released under the MIT license.
   */
import e from"path";import t from"fs-extra";import n from"chalk";import r from"p-queue";import i,{ScriptTarget as s,SyntaxKind as o}from"typescript";import a from"postcss";import c from"autoprefixer";import u from"tailwindcss/lib/processTailwindFeatures";import l from"tailwindcss/lib/public/resolve-config";import f from"postcss-load-config";import d from"cssnano";import p from"postcss-combine-duplicated-selectors";let m,w=!1;function g(...e){w&&console.log(n.bold.blue("[DBG]"),...e)}function h(...e){console.log(n.bold.bgRedBright("[ERR]"),n.bold.red(...e))}const y={DEFAULT:{enableDebug:!1,tailwindCssPath:void 0,tailwindCssContents:"@tailwind base;@tailwind utilities;@tailwind components;",tailwindConf:{content:[],theme:{extend:{}},plugins:[]},stripComments:!1,minify:!0,useAutoPrefixer:!0}};function x(){return null!=m?m:y.DEFAULT}function v(r){const i=t.readFileSync(e.resolve(r)).toString();return 0===i.length?(function(...e){console.log(n.bold.yellowBright("[WRN]"),...e)}("No css found when reading Tailwind configuration css - path",r),null):i}function b(e){return i.createSourceFile("placeholder.ts",e,s.Latest)}function S(e){return function(t,n){const r=e[n];if(r&&t.kind===r.nodeKind){if(r.has){if(!t.modifiers)return!1;let e=!1;for(let n=0;n<t.modifiers.length;++n)if(t.modifiers[n].kind===r.has){e=!0;break}if(!e)return!1}return r.name?t.name&&t.name.escapedText===r.name:!r.initializerKind||t.initializer&&t.initializer.kind===r.initializerKind}return!1}}function E(e,t){const n=S(t);let r=0;return function e(s){return n(s,r)&&(r++,r===t.length)?s:i.forEachChild(s,e)}(e)}function O(e,{name:t,modifier:n,initializer:r}={}){return{nodeKind:e,name:t,has:n,initializerKind:r}}function T(e,t){let n=0;const r=S(e);return function(s){function a(c){return g("[Typescript]","Visiting "+o[c.kind]),r(c,n)?(n++,n===e.length?t(c):(g("[Typescript]","Moving to next tree level",n,"looking for",o[e[n].nodeKind]),c=i.visitEachChild(c,a,s))):c}return function(e){return i.visitNode(e,a)}}}function C(e){return e&&e.__esModule&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e}var F={exports:{}},P={exports:{}};!function(e,t){function n(e){this.options=e}Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0,n.prototype.canRemove=function(e){const t=this.options.remove;if(t)return t(e);if(!(0===e.indexOf("!")))return!0;if(this.options.removeAll||this._hasFirst)return!0;if(this.options.removeAllButFirst&&!this._hasFirst)return this._hasFirst=!0,!1};var r=n;t.default=r,e.exports=t.default}(P,P.exports);var R,j,A={exports:{}};R=A,j=A.exports,Object.defineProperty(j,"__esModule",{value:!0}),j.default=function(e){const t=[],n=e.length;let r,i=0;for(;i<n;)r=e.indexOf("/*",i),~r?(t.push([0,i,r]),i=r,r=e.indexOf("*/",i+2),t.push([1,i+2,r]),i=r+2):(t.push([0,i,n]),i=n);return t},R.exports=j.default,function(e,t){Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(P.exports),r=i(A.exports);function i(e){return e&&e.__esModule?e:{default:e}}function s(e={}){const t=new n.default(e),i={},s={};function o(e,n,i=" "){const o=e+"@|@"+i;if(s[o])return s[o];const a=n((0,r.default)(e).reduce(((n,[r,s,o])=>{const a=e.slice(s,o);return r?t.canRemove(a)?n+i:`${n}/*${a}*/`:n+a}),"")).join(" ");return s[o]=a,a}return{postcssPlugin:"postcss-discard-comments",OnceExit(e,{list:n}){e.walk((e=>{if("comment"===e.type&&t.canRemove(e.text))e.remove();else if(e.raws.between&&(e.raws.between=o(e.raws.between,n.space)),"decl"!==e.type){if("rule"===e.type&&e.raws.selector&&e.raws.selector.raw)e.raws.selector.raw=o(e.raws.selector.raw,n.space,"");else if("atrule"===e.type){if(e.raws.afterName){const t=o(e.raws.afterName,n.space);t.length?e.raws.afterName=" "+t+" ":e.raws.afterName=t+" "}e.raws.params&&e.raws.params.raw&&(e.raws.params.raw=o(e.raws.params.raw,n.space))}}else if(e.raws.value&&e.raws.value.raw&&(e.raws.value.value===e.value?e.value=o(e.raws.value.raw,n.space):e.value=o(e.value,n.space),e.raws.value=null),e.raws.important){e.raws.important=o(e.raws.important,n.space);const t=function(e){if(i[e])return i[e];const t=(0,r.default)(e).filter((([e])=>e));return i[e]=t,t}(e.raws.important);e.raws.important=t.length?e.raws.important:"!important"}}))}}}s.postcss=!0;var o=s;t.default=o,e.exports=t.default}(F,F.exports);var D=C(F.exports);function _(e,t){return e.findIndex((e=>"function"==typeof e&&e.name===t||"object"==typeof e&&null!==e&&(e.postcssPlugin===t||e.name===t)))}function k(){return D({removeAll:!0})}function N(){return[p(),d()]}async function $(){const e=x(),t=await async function(e){const t={plugins:[]};let n="";if("object"==typeof e&&!Array.isArray(e)&&null!==e&&Array.isArray(e.plugins))return e.plugins;("string"==typeof e||e instanceof String)&&(n=e);try{return(await f(t,n)).plugins}catch(t){if("MODULE_NOT_FOUND"===t.code)throw new Error(`'stencil-tailwind-plugin' is not able to resolve modules required from configuration files. Make sure it is installed\nError: ${t.message}`);g("[TW]","No postcss configuration file found in:",e)}return[]}(e.postcss),n=_(t,"tailwindcss"),r=-1!==_(t,"autoprefixer");return{before:-1===n?[]:t.slice(0,n),after:-1===n?t:t.slice(n+1),hasAutoPrefixer:r}}async function z(e,t){const n=x(),r=(i=[e],Object.assign({},m.tailwindConf,{content:i}));var i;const{before:s,after:o,hasAutoPrefixer:a}=await $(),f=[...s,function(e,t){const n=()=>({postcssPlugin:"tailwindcss",Once(n,{result:r}){u((({createContext:n})=>()=>n(l(e),[t])))(n,r)}});return n.postcss=!0,n}(r,{content:t,extension:"tsx"}),...o];return n.useAutoPrefixer&&!a&&f.push(c()),n.minify&&f.push(...N()),n.stripComments&&f.push(k()),f}async function L(e,t,n){const r=x(),i=`${r.tailwindCssContents} ${null!=n?n:""}`,s=await z(e,t),o=function(e,t){return t?e:e.replace(/\n/g,"").replace(/'/g,'"').replace(/`/g,"\\`").replace(/\t/g," ")}((await a(s).process(i,{from:e})).css,r.minify);return g("[TW]","Tailwind styles:",o),o}const V=[];function K(e){return e.replace(/\\/g,"/")}function M(t){const n=e.parse(t);return K(e.join(n.dir,n.name))}function B(e,t){const n=K(e),r=t.map(M),i=function(e){return V.find((t=>t.name===e))}(n);if(void 0===i)return g("[STORE]","Registered",r,"with",n),void V.push(function(e,t){return{imports:t,cssFiles:{},name:e}}(n,r));g("[STORE]","Updated",r,"with",n),i.imports.push(...r)}function U(e,t){const n=K(e);g("[STORE]","Registering css for",n,"against",t);const r=function(e){const t=M(e);return function(n){return-1!==n.imports.indexOf(t)||n.name===e}}(n);V.forEach((e=>{r(e)&&(g("[STORE]","Found cross reference for imported file",e.name,"to store css against"),e.cssFiles[n]={name:n,css:t})}))}function I(e){const t=K(e);g("[STORE]","Looking up import of",t);const n=function(e){const t=M(e);return g("[STORE]","Import spec for matching",t),V.filter((e=>e.imports.includes(t)))}(t).reduce(((e,t)=>(e.css+=Object.entries(t.cssFiles).reduce(((t,[n,r])=>(t+=r.css,e.dependencies.push(r.name),t)),""),e)),{css:"",dependencies:[]});return g("[STORE]","Injecting css",n),n}async function W(t,n,r){const s=[O(o.SourceFile),O(o.FirstStatement),O(o.VariableDeclarationList),O(o.VariableDeclaration),O(o.StringLiteral)],c=I(r).css,u=E(t,s);await(async t=>{const i=t.text,s=await L(r,n,i),o=await async function(t,n,r){const{minify:i,stripComments:s}=x(),o=n+r;if(!i||0===r.length)return o;const c=e.join(".",e.relative(process.cwd(),t)),u=N();return s&&u.push(k()),(await a(u).process(o,{from:c})).css}(r,s,c);t.text=o})(u);return i.createPrinter().printFile(t)}function q(e,t){const n=[O(o.SourceFile),O(o.VariableStatement),O(o.VariableDeclarationList),O(o.VariableDeclaration,{initializer:o.ClassExpression})];let r="";const s=function(e,t,n){let r=!1;const s=i.transform(e,[T(t,(function(e){return g("Found Node, calling user processing"),r=!0,n(e)}))]),[o]=s.transformed,a=i.createPrinter();return{found:r,fullText:a.printFile(o)}}(e,n,(e=>{const t=e;return t.name&&t.initializer&&t.initializer.kind===o.ClassExpression&&(r=t.name.escapedText),e}));if(s.found){const e=i.factory.createIdentifier(`'${t}'`);s.fullText=`${s.fullText}${r}.style = ${e.escapedText};\n`}return s}function G(t,n){const r=e.parse(n),s=[];!function(e,t,n){(function e(r){return r.kind===t&&n(r)?r:i.forEachChild(r,e)})(e)}(t,o.ImportDeclaration,(function(t){const n=t.moduleSpecifier,i=e.resolve(r.dir,n.text);return s.push(i),!1})),B(n,s)}function H(e,t){if(function(e){return void 0!==E(e,[O(o.SourceFile),O(o.VariableStatement,{modifier:o.ExportKeyword}),O(o.VariableDeclarationList),O(o.VariableDeclaration),O(o.ClassExpression),O(o.GetAccessor,{name:"style",modifier:o.StaticKeyword}),O(o.Block),O(o.ReturnStatement)])}(e)||function(e){return void 0!==E(e,[O(o.SourceFile),O(o.ExpressionStatement),O(o.BinaryExpression)])}(e))return{transformed:!1};const n=q(e,t);return{text:n.fullText,transformed:n.found}}function J(){g("Starting build")}function Q(e){e&&(h("Oh noes! Something went wrong!",e.message),h(e.stack)),g("Build completed")}const X=new r({concurrency:1});async function Y(e,t){return await X.add((async()=>{let n=e;return t.match(/\.s?css/)?n=await async function(e,t){g("[Stylesheets]","Processing source file:",t);const n=b(e);return await W(n,e,t)}(e,t):function(e){return e.match(/\.tsx/)}(t)&&(n=await async function(e,t){g("[Typescript]","Processing source file:",t);const n=await L(t,e);if(0===n.length)return e;const r=n.replace(/\\/g,"\\\\"),i=b(e);G(i,t);const s=H(i,r);return s.transformed?s.text:(U(t,n),e)}(e,t)),{code:n,map:null}}))}async function Z(e,t){return await X.add((async()=>{const n=I(t);return{code:""===n.css?e:`${e} ${n.css}`,map:null,dependencies:n.dependencies}}))}const ee=Object.freeze(y);function te(e){const t=Object.assign({},ee.DEFAULT,e);var n;!function(e){var t;m=Object.assign({},e),m.tailwindCssPath&&(m.tailwindCssContents=null!==(t=v(m.tailwindCssPath))&&void 0!==t?t:m.tailwindCssContents)}(t),n=t.enableDebug,w=n}function ne(e){return te(e),{name:"tailwind",transform:Y,buildStart:J,buildEnd:Q}}function re(){return{pluginType:"css",name:"tailwind-hmr",transform:Z,buildStart:J,buildEnd:Q}}export{ee as PluginOpts,ne as default,re as tailwindHMR};
//# sourceMappingURL=index.esm.js.map
