/**
   * @license
   * author: Richard Shephard
   * stencil-tailwind-plugin.js v1.2.1
   * Released under the MIT license.
   */
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("path"),t=require("fs-extra"),n=require("chalk"),i=require("p-queue"),r=require("typescript"),s=require("postcss"),a=require("autoprefixer"),o=require("tailwindcss/lib/processTailwindFeatures"),u=require("tailwindcss/lib/public/resolve-config"),c=require("postcss-load-config"),l=require("cssnano"),f=require("postcss-combine-duplicated-selectors");function d(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}var p=d(e),m=d(t),w=d(n),x=d(i),y=d(r),g=d(s),h=d(a),S=d(o),v=d(u),b=d(c),K=d(l),O=d(f);let T,E=!1;function C(...e){E&&console.log(w.default.bold.blue("[DBG]"),...e)}function F(...e){console.log(w.default.bold.bgRedBright("[ERR]"),w.default.bold.red(...e))}const P={DEFAULT:{enableDebug:!1,tailwindCssPath:void 0,tailwindCssContents:"@tailwind base;@tailwind utilities;@tailwind components;",tailwindConf:{content:[],theme:{extend:{}},plugins:[]},stripComments:!1,minify:!0,useAutoPrefixer:!0}};function R(){return null!=T?T:P.DEFAULT}function j(e){const t=m.default.readFileSync(p.default.resolve(e)).toString();return 0===t.length?(function(...e){console.log(w.default.bold.yellowBright("[WRN]"),...e)}("No css found when reading Tailwind configuration css - path",e),null):t}function _(e){return y.default.createSourceFile("placeholder.ts",e,r.ScriptTarget.Latest)}function A(e){return function(t,n){const i=e[n];if(i&&t.kind===i.nodeKind){if(i.has){if(!t.modifiers)return!1;let e=!1;for(let n=0;n<t.modifiers.length;++n)if(t.modifiers[n].kind===i.has){e=!0;break}if(!e)return!1}return i.name?t.name&&t.name.escapedText===i.name:!i.initializerKind||t.initializer&&t.initializer.kind===i.initializerKind}return!1}}function D(e,t){const n=A(t);let i=0;return function e(r){return n(r,i)&&(i++,i===t.length)?r:y.default.forEachChild(r,e)}(e)}function k(e,{name:t,modifier:n,initializer:i}={}){return{nodeKind:e,name:t,has:n,initializerKind:i}}function q(e,t){let n=0;const i=A(e);return function(s){function a(o){return C("[Typescript]","Visiting "+r.SyntaxKind[o.kind]),i(o,n)?(n++,n===e.length?t(o):(C("[Typescript]","Moving to next tree level",n,"looking for",r.SyntaxKind[e[n].nodeKind]),o=y.default.visitEachChild(o,a,s))):o}return function(e){return y.default.visitNode(e,a)}}}function N(e){return e&&e.__esModule&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e}var $={exports:{}},z={exports:{}};!function(e,t){function n(e){this.options=e}Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0,n.prototype.canRemove=function(e){const t=this.options.remove;if(t)return t(e);if(!(0===e.indexOf("!")))return!0;if(this.options.removeAll||this._hasFirst)return!0;if(this.options.removeAllButFirst&&!this._hasFirst)return this._hasFirst=!0,!1};var i=n;t.default=i,e.exports=t.default}(z,z.exports);var L={exports:{}};!function(e,t){Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){const t=[],n=e.length;let i,r=0;for(;r<n;)i=e.indexOf("/*",r),~i?(t.push([0,r,i]),r=i,i=e.indexOf("*/",r+2),t.push([1,r+2,i]),r=i+2):(t.push([0,r,n]),r=n);return t},e.exports=t.default}(L,L.exports),function(e,t){Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=r(z.exports),i=r(L.exports);function r(e){return e&&e.__esModule?e:{default:e}}function s(e={}){const t=new n.default(e),r={},s={};function a(e,n,r=" "){const a=e+"@|@"+r;if(s[a])return s[a];const o=n((0,i.default)(e).reduce(((n,[i,s,a])=>{const o=e.slice(s,a);return i?t.canRemove(o)?n+r:`${n}/*${o}*/`:n+o}),"")).join(" ");return s[a]=o,o}return{postcssPlugin:"postcss-discard-comments",OnceExit(e,{list:n}){e.walk((e=>{if("comment"===e.type&&t.canRemove(e.text))e.remove();else if(e.raws.between&&(e.raws.between=a(e.raws.between,n.space)),"decl"!==e.type){if("rule"===e.type&&e.raws.selector&&e.raws.selector.raw)e.raws.selector.raw=a(e.raws.selector.raw,n.space,"");else if("atrule"===e.type){if(e.raws.afterName){const t=a(e.raws.afterName,n.space);t.length?e.raws.afterName=" "+t+" ":e.raws.afterName=t+" "}e.raws.params&&e.raws.params.raw&&(e.raws.params.raw=a(e.raws.params.raw,n.space))}}else if(e.raws.value&&e.raws.value.raw&&(e.raws.value.value===e.value?e.value=a(e.raws.value.raw,n.space):e.value=a(e.value,n.space),e.raws.value=null),e.raws.important){e.raws.important=a(e.raws.important,n.space);const t=function(e){if(r[e])return r[e];const t=(0,i.default)(e).filter((([e])=>e));return r[e]=t,t}(e.raws.important);e.raws.important=t.length?e.raws.important:"!important"}}))}}}s.postcss=!0;var a=s;t.default=a,e.exports=t.default}($,$.exports);var M=N($.exports);function V(e,t){return e.findIndex((e=>"function"==typeof e&&e.name===t||"object"==typeof e&&null!==e&&(e.postcssPlugin===t||e.name===t)))}function B(){return M({removeAll:!0})}function U(){return[O.default(),K.default()]}async function I(){const e=R(),t=await async function(e){const t={plugins:[]};let n="";if("object"==typeof e&&!Array.isArray(e)&&null!==e&&Array.isArray(e.plugins))return e.plugins;("string"==typeof e||e instanceof String)&&(n=e);try{return(await b.default(t,n)).plugins}catch(t){if("MODULE_NOT_FOUND"===t.code)throw new Error(`'stencil-tailwind-plugin' is not able to resolve modules required from configuration files. Make sure it is installed\nError: ${t.message}`);C("[TW]","No postcss configuration file found in:",e)}return[]}(e.postcss),n=V(t,"tailwindcss"),i=-1!==V(t,"autoprefixer");return{before:-1===n?[]:t.slice(0,n),after:-1===n?t:t.slice(n+1),hasAutoPrefixer:i}}async function W(e,t){const n=R(),i=(r=[e],Object.assign({},T.tailwindConf,{content:r}));var r;const{before:s,after:a,hasAutoPrefixer:o}=await I(),u=[...s,function(e,t){const n=()=>({postcssPlugin:"tailwindcss",Once(n,{result:i}){S.default((({createContext:n})=>()=>n(v.default(e),[t])))(n,i)}});return n.postcss=!0,n}(i,{content:t,extension:"tsx"}),...a];return n.useAutoPrefixer&&!o&&u.push(h.default()),n.minify&&u.push(...U()),n.stripComments&&u.push(B()),u}async function G(e,t,n){const i=R(),r=`${i.tailwindCssContents} ${null!=n?n:""}`,s=await W(e,t),a=function(e,t){return t?e:e.replace(/\n/g,"").replace(/'/g,'"').replace(/`/g,"\\`").replace(/\t/g," ")}((await g.default(s).process(r,{from:e})).css,i.minify);return C("[TW]","Tailwind styles:",a),a}const H=[];function J(e){return e.replace(/\\/g,"/")}function Q(e){const t=p.default.parse(e);return J(p.default.join(t.dir,t.name))}function X(e,t){const n=J(e),i=t.map(Q),r=function(e){return H.find((t=>t.name===e))}(n);if(void 0===r)return C("[STORE]","Registered",i,"with",n),void H.push(function(e,t){return{imports:t,cssFiles:{},name:e}}(n,i));C("[STORE]","Updated",i,"with",n),r.imports.push(...i)}function Y(e,t){const n=J(e);C("[STORE]","Registering css for",n,"against",t);const i=function(e){const t=Q(e);return function(n){return-1!==n.imports.indexOf(t)||n.name===e}}(n);H.forEach((e=>{i(e)&&(C("[STORE]","Found cross reference for imported file",e.name,"to store css against"),e.cssFiles[n]={name:n,css:t})}))}function Z(e){const t=J(e);C("[STORE]","Looking up import of",t);const n=function(e){const t=Q(e);return C("[STORE]","Import spec for matching",t),H.filter((e=>e.imports.includes(t)))}(t).reduce(((e,t)=>(e.css+=Object.entries(t.cssFiles).reduce(((t,[n,i])=>(t+=i.css,e.dependencies.push(i.name),t)),""),e)),{css:"",dependencies:[]});return C("[STORE]","Injecting css",n),n}async function ee(e,t,n){const i=[k(r.SyntaxKind.SourceFile),k(r.SyntaxKind.FirstStatement),k(r.SyntaxKind.VariableDeclarationList),k(r.SyntaxKind.VariableDeclaration),k(r.SyntaxKind.StringLiteral)],s=Z(n).css,a=D(e,i);await(async e=>{const i=e.text,r=await G(n,t,i),a=await async function(e,t,n){const{minify:i,stripComments:r}=R(),s=t+n;if(!i||0===n.length)return s;const a=p.default.join(".",p.default.relative(process.cwd(),e)),o=U();return r&&o.push(B()),(await g.default(o).process(s,{from:a})).css}(n,r,s);e.text=a})(a);return y.default.createPrinter().printFile(e)}function te(e,t){const n=[k(r.SyntaxKind.SourceFile),k(r.SyntaxKind.VariableStatement),k(r.SyntaxKind.VariableDeclarationList),k(r.SyntaxKind.VariableDeclaration,{initializer:r.SyntaxKind.ClassExpression})];let i="";const s=function(e,t,n){let i=!1;const r=y.default.transform(e,[q(t,(function(e){return C("Found Node, calling user processing"),i=!0,n(e)}))]),[s]=r.transformed,a=y.default.createPrinter();return{found:i,fullText:a.printFile(s)}}(e,n,(e=>{const t=e;return t.name&&t.initializer&&t.initializer.kind===r.SyntaxKind.ClassExpression&&(i=t.name.escapedText),e}));if(s.found){const e=y.default.factory.createIdentifier(`'${t}'`);s.fullText=`${s.fullText}${i}.style = ${e.escapedText};\n`}return s}function ne(e,t){const n=p.default.parse(t),i=[];!function(e,t,n){(function e(i){return i.kind===t&&n(i)?i:y.default.forEachChild(i,e)})(e)}(e,r.SyntaxKind.ImportDeclaration,(function(e){const t=e.moduleSpecifier,r=p.default.resolve(n.dir,t.text);return i.push(r),!1})),X(t,i)}function ie(e,t){if(function(e){return void 0!==D(e,[k(r.SyntaxKind.SourceFile),k(r.SyntaxKind.VariableStatement,{modifier:r.SyntaxKind.ExportKeyword}),k(r.SyntaxKind.VariableDeclarationList),k(r.SyntaxKind.VariableDeclaration),k(r.SyntaxKind.ClassExpression),k(r.SyntaxKind.GetAccessor,{name:"style",modifier:r.SyntaxKind.StaticKeyword}),k(r.SyntaxKind.Block),k(r.SyntaxKind.ReturnStatement)])}(e)||function(e){return void 0!==D(e,[k(r.SyntaxKind.SourceFile),k(r.SyntaxKind.ExpressionStatement),k(r.SyntaxKind.BinaryExpression)])}(e))return{transformed:!1};const n=te(e,t);return{text:n.fullText,transformed:n.found}}function re(){C("Starting build")}function se(e){e&&(F("Oh noes! Something went wrong!",e.message),F(e.stack)),C("Build completed")}const ae=new x.default({concurrency:1});async function oe(e,t){return await ae.add((async()=>{let n=e;return t.match(/\.s?css/)?n=await async function(e,t){C("[Stylesheets]","Processing source file:",t);const n=_(e);return await ee(n,e,t)}(e,t):function(e){return e.match(/\.tsx/)}(t)&&(n=await async function(e,t){C("[Typescript]","Processing source file:",t);const n=await G(t,e);if(0===n.length)return e;const i=n.replace(/\\/g,"\\\\"),r=_(e);ne(r,t);const s=ie(r,i);return s.transformed?s.text:(Y(t,n),e)}(e,t)),{code:n,map:null}}))}async function ue(e,t){return await ae.add((async()=>{const n=Z(t);return{code:""===n.css?e:`${e} ${n.css}`,map:null,dependencies:n.dependencies}}))}const ce=Object.freeze(P);function le(e){const t=Object.assign({},ce.DEFAULT,e);var n;!function(e){var t;T=Object.assign({},e),T.tailwindCssPath&&(T.tailwindCssContents=null!==(t=j(T.tailwindCssPath))&&void 0!==t?t:T.tailwindCssContents)}(t),n=t.enableDebug,E=n}exports.PluginOpts=ce,exports.default=function(e){return le(e),{name:"tailwind",transform:oe,buildStart:re,buildEnd:se}},exports.tailwindHMR=function(){return{pluginType:"css",name:"tailwind-hmr",transform:ue,buildStart:re,buildEnd:se}};
//# sourceMappingURL=index.js.map
